# Billing # Profiles ## Billing Profile Details `billing.profiles.get(ProfileGetParams**kwargs) -> ProfileGetResponse` **get** `/accounts/{account_id}/billing/profile` Gets the current billing profile for the account. ### Parameters - `account_id: str` Identifier ### Returns - `class ProfileGetResponse: …` - `id: Optional[str]` Billing item identifier tag. - `account_type: Optional[str]` - `address: Optional[str]` - `address2: Optional[str]` - `balance: Optional[str]` - `card_expiry_month: Optional[int]` - `card_expiry_year: Optional[int]` - `card_number: Optional[str]` - `city: Optional[str]` - `company: Optional[str]` - `country: Optional[str]` - `created_on: Optional[datetime]` - `device_data: Optional[str]` - `edited_on: Optional[datetime]` - `enterprise_billing_email: Optional[str]` - `enterprise_primary_email: Optional[str]` - `first_name: Optional[str]` - `is_partner: Optional[bool]` - `last_name: Optional[str]` - `next_bill_date: Optional[datetime]` - `payment_address: Optional[str]` - `payment_address2: Optional[str]` - `payment_city: Optional[str]` - `payment_country: Optional[str]` - `payment_email: Optional[str]` - `payment_first_name: Optional[str]` - `payment_gateway: Optional[str]` - `payment_last_name: Optional[str]` - `payment_nonce: Optional[str]` - `payment_state: Optional[str]` - `payment_zipcode: Optional[str]` - `primary_email: Optional[str]` - `state: Optional[str]` - `tax_id_type: Optional[str]` - `telephone: Optional[str]` - `use_legacy: Optional[bool]` - `validation_code: Optional[str]` - `vat: Optional[str]` - `zipcode: Optional[str]` ### Example ```python import os from cloudflare import Cloudflare client = Cloudflare( api_token=os.environ.get("CLOUDFLARE_API_TOKEN"), # This is the default and can be omitted ) profile = client.billing.profiles.get( account_id="023e105f4ecef8ad9ca31a8372d0c353", ) print(profile.id) ``` #### Response ```json { "errors": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "messages": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "result": { "id": "b69a9f3492637782896352daae219e7d", "account_type": "type", "address": "123 Main Street", "address2": "Apt 1", "balance": "0", "card_expiry_month": 12, "card_expiry_year": 2099, "card_number": "4242424242424242", "city": "Anytown", "company": "Company", "country": "Anycountry", "created_on": "2014-03-01T12:21:59.3456Z", "device_data": "sample_data", "edited_on": "2014-03-01T12:21:59.3456Z", "enterprise_billing_email": "johndoe@gmail.com", "enterprise_primary_email": "johndoe@gmail.com", "first_name": "John", "is_partner": false, "last_name": "Doe", "next_bill_date": "2014-03-01T12:21:59.3456Z", "payment_address": "123 Main Street", "payment_address2": "Apt 1", "payment_city": "Anytown", "payment_country": "Anycountry", "payment_email": "johndoe@gmail.com", "payment_first_name": "John", "payment_gateway": "gateway", "payment_last_name": "Doe", "payment_nonce": "abc123", "payment_state": "state", "payment_zipcode": "12345", "primary_email": "johndoe@gmail.com", "state": "AnyState", "tax_id_type": "type", "telephone": "1234567899", "use_legacy": false, "validation_code": "1111", "vat": "GB123456789", "zipcode": "12345" }, "success": true } ``` ## Domain Types ### Profile Get Response - `class ProfileGetResponse: …` - `id: Optional[str]` Billing item identifier tag. - `account_type: Optional[str]` - `address: Optional[str]` - `address2: Optional[str]` - `balance: Optional[str]` - `card_expiry_month: Optional[int]` - `card_expiry_year: Optional[int]` - `card_number: Optional[str]` - `city: Optional[str]` - `company: Optional[str]` - `country: Optional[str]` - `created_on: Optional[datetime]` - `device_data: Optional[str]` - `edited_on: Optional[datetime]` - `enterprise_billing_email: Optional[str]` - `enterprise_primary_email: Optional[str]` - `first_name: Optional[str]` - `is_partner: Optional[bool]` - `last_name: Optional[str]` - `next_bill_date: Optional[datetime]` - `payment_address: Optional[str]` - `payment_address2: Optional[str]` - `payment_city: Optional[str]` - `payment_country: Optional[str]` - `payment_email: Optional[str]` - `payment_first_name: Optional[str]` - `payment_gateway: Optional[str]` - `payment_last_name: Optional[str]` - `payment_nonce: Optional[str]` - `payment_state: Optional[str]` - `payment_zipcode: Optional[str]` - `primary_email: Optional[str]` - `state: Optional[str]` - `tax_id_type: Optional[str]` - `telephone: Optional[str]` - `use_legacy: Optional[bool]` - `validation_code: Optional[str]` - `vat: Optional[str]` - `zipcode: Optional[str]` # Usage ## Get PayGo Account Billable Usage (Beta) `billing.usage.paygo(UsagePaygoParams**kwargs) -> UsagePaygoResponse` **get** `/accounts/{account_id}/billing/usage/paygo` Returns billable usage data for PayGo (self-serve) accounts. When no query parameters are provided, returns usage for the current billing period. This endpoint is currently in beta and access is restricted to select accounts. ### Parameters - `account_id: str` Represents a Cloudflare resource identifier tag. - `from_: Optional[Union[null, null]]` Defines the start date for the usage query (e.g., 2025-02-01). - `to: Optional[Union[null, null]]` Defines the end date for the usage query (e.g., 2025-03-01). ### Returns - `List[UsagePaygoResponseItem]` Contains the array of billable usage records. - `billing_currency: str` Specifies the billing currency code (ISO 4217). - `billing_period_start: datetime` Indicates the start of the billing period. - `charge_period_end: datetime` Indicates the end of the charge period. - `charge_period_start: datetime` Indicates the start of the charge period. - `consumed_quantity: float` Specifies the quantity consumed during this charge period. - `consumed_unit: str` Specifies the unit of measurement for consumed quantity. - `contracted_cost: float` Specifies the cost for this charge period in the billing currency. - `cumulated_contracted_cost: float` Specifies the cumulated cost for the billing period in the billing currency. - `cumulated_pricing_quantity: int` Specifies the cumulated pricing quantity for the billing period. - `pricing_quantity: int` Specifies the pricing quantity for this charge period. - `service_name: str` Identifies the Cloudflare service. ### Example ```python import os from cloudflare import Cloudflare client = Cloudflare( api_token=os.environ.get("CLOUDFLARE_API_TOKEN"), # This is the default and can be omitted ) response = client.billing.usage.paygo( account_id="023e105f4ecef8ad9ca31a8372d0c353", ) print(response) ``` #### Response ```json { "errors": [ { "message": "message", "code": 0 } ], "messages": [ { "message": "message", "code": 0 } ], "result": [ { "BillingCurrency": "USD", "BillingPeriodStart": "2025-02-01T00:00:00Z", "ChargePeriodEnd": "2025-02-02T00:00:00Z", "ChargePeriodStart": "2025-02-01T00:00:00Z", "ConsumedQuantity": 150000, "ConsumedUnit": "Requests", "ContractedCost": 0.75, "CumulatedContractedCost": 2.25, "CumulatedPricingQuantity": 4500000, "PricingQuantity": 150000, "ServiceName": "Workers Standard" } ], "success": true } ``` ## Domain Types ### Usage Paygo Response - `List[UsagePaygoResponseItem]` Contains the array of billable usage records. - `billing_currency: str` Specifies the billing currency code (ISO 4217). - `billing_period_start: datetime` Indicates the start of the billing period. - `charge_period_end: datetime` Indicates the end of the charge period. - `charge_period_start: datetime` Indicates the start of the charge period. - `consumed_quantity: float` Specifies the quantity consumed during this charge period. - `consumed_unit: str` Specifies the unit of measurement for consumed quantity. - `contracted_cost: float` Specifies the cost for this charge period in the billing currency. - `cumulated_contracted_cost: float` Specifies the cumulated cost for the billing period in the billing currency. - `cumulated_pricing_quantity: int` Specifies the cumulated pricing quantity for the billing period. - `pricing_quantity: int` Specifies the pricing quantity for this charge period. - `service_name: str` Identifies the Cloudflare service.